Ver.4.1.0:
+ new keys gpumem*, gpuused*, gputot*, gpufree* for GPU memory (#175)
* rewrite dataengine processor to work in signleton mode (#174)

Ver.4.0.3:
- drop qml definition to avoid compile errors

Ver.4.0.2:
+ German translation (#172, thanks to daveedmee)

Ver.4.0.1:
- temporary disable tooltip painting in main widget

Ver.4.0.0:
* migration to plasma 6
* dialog windows have been replaced by notifications
+ $gpuN keys have been added
+ new key $ssid
- $cuptime key has been removed in favour of $uptime
- $gputemp key has been replaced by $gpuN

Ver.3.5.0:
+ wayland support
* update code to latest standards
- drop support of windows preview

Ver.3.4.2:
+ Italian translation (#136, thanks to @avivace)
+ stooq quotes support (default) (#131)
+ Indonesian translation (#132, thanks to @ibnuda)
+ new keys - $batleftN, $batnowN, $batrateN, $battotalN, $brightness, $volume
* fix compiler warnings
* update to new qt api
- fix non printable spaces (#142, #143)

Ver.3.3.3:
+ add custom keys support (#101)
* DBus interface improvements
* rename tags (up|down|ps)total.* to (up|down|ps)tot.*
- fix issue with invalid (up|down)total($|kb) calculation (#127)
- fix issue with wrong applet identation (#125)

Ver.3.3.2:
- fix bug with invalid DP colour configuration
- fix bug with invalid HTML tags operation
* update to newest Qt and plasma

Ver.3.3.1:
+ add ability to direct issue report (#104)
+ add key completion (#105)
+ add ability to load historical configuration (#106)
+ add ability to upload configuration to remote server (#106)
+ add stylish (#112)
+ add DBus intergration (#115)
+ add cron-like extenstion triggers (`X-AW-Socket` option) (#117)
+ add ability to trigger extensions by calling socket (`X-AW-Schedule` option) (#118)
+ add source for network requests
+ add Json formatter
- drop patches provided support for Qt 5.4
* use custom signal slot connection for dataengine (`BUILD_FUTURE` flag required)
* update UI
* refactoring

Ver.3.2.1:
+ add X-AW-Translate option to DateTime formatter
+ add formatters to configuration export and import
+ add macro fuction to selector
+ add default formatters
- add translation reinit (fix #102)
- fix invalid float formatter saving
- fix missing ApiVersion for formatters
* use sockets for MPD data
* translation update

Ver.3.2.0:
+ custom formatters (#91)
+ add backend tests (#95)
+ add OWM weather provider for ExtWeather. It can be switched by using X-AW-Provider (ApiVer 3)
+ add DBus timeout for calls (#96)
+ add macros support (`$aw_macro` and `$aw_macro_*` for calls)
- fix vertical alignment (#94)
- fix bug with invalid updates on `X-AW-Interval=1` for ExtScript and ExtUpgrade
- fix bug with missing derivate vaules in ExtQuotes
- fix possible plasma crash (#96)
- fix possible undefined behaviour if no extensions was found by name
* split dataengine sources to own library
* allow to use screened double brakets inside functions

Ver.3.1.2:
+ add standalone widget configuration example
+ new tag tstime
+ new tags uptotal* and downtotal*
+ add background configuration button
+ allow X-AW-Direction property works with graphs and bars (graphical items)
+ add bars support to Graphical Items
+ add integration with transifex
+ add integration with coverity
- drop update source (breaking changes if you are using it as developer)
- fix pen generation from file image (graphical items)
- fix bug with which font html parameters will be pasted even if there cancel clicked
- fix bug with invalid total memory formating
- fix bug in configuration UI with which there is no selected text pasted
- fixes in graphical item configuration UI and behaviour
- fix changelog building
- fix invalid cast (found by coverity)
* change text update mechanism
* grahical item improvements
* code improvements
* translation update

Ver.3.1.1:
- fix broken gcc build (#87)
* translation update

Ver.3.1.0:
+ implement templates support (#71)
+ implement special functions (#71)
+ special directory for configs (#72)
+ custom bar images (#80)
+ custom bar values (#80)
+ show changelog after updates
+ add Polish translation (thanks to Mariusz Kocoń)
+ use Qt-5.6 features
- fix invalid tooltip resize in desktop panel (#74)
- fix graphical items blinking (#81)
- drop tasks and move to native QProcess to avoid crash (#83)
- the newest Qt (5.6) fixes
- the newest Plasma fixes
* move from OWM to Yahoo! Weather (#73)
* improve performance by using optimized subscriptions (#75)
* improve performance by storing QVariant instead of frequent casting (#75)
* change bar names semantic to the simplest one (#80, breaking changes)
* high memory usage notifications have been changed from 90 to 80 perc
* a large part of refactoring

Ver.3.0.1:
+ add patches for old Qt versions
- drop `nullptr` checking
* move dialogs to QML part

Ver.3.0.0:
+ add tags upunits, downunits, upkb, downkb
+ add tags dalbum, dartist, dtitle, salbum, sartist, stitle
+ add support of lambda functions
+ add Dutch translation (thanks to Heimen Stoffels)
+ add check for update function on startup (optional)
+ add ability to disable string tags translations
+ add filtering to ExtUpgrade (ApiVer == 3)
+ add ability to change weather icons (ApiVer == 2)
+ show message if no updates found on direct request
+ add swap redirect type to ExtScript (ApiVer == 4)
+ add ability to wrap words
+ add support of graphs to GraphicalItems (ApiVer == 3)
+ add ability to show preview from configuration
+ add configuration export and import functions
- fix warning for empty tooltip image
- fix bug with widget auto resizing
- fix bug with no settings saving in DE
- fix bug with large start size
- fix bug with no possibility use more than 10 ext tags
- drop HDD free space notifications
- drop X-AW-Output key for ExtScript (ApiVer == 4)
- fix possible crash on web sources destruction
* more pretty configuration ui
* improve logging, change format to Qt5 style
* switch to concurrent data update
* some more optimization
* better network device definition
* quotes values now have double type (ApiVer == 3)
* better quotes output
* more comments inside code
* more Qt code style
* move update interval to another group
* move DataEnignes operations to plugin
* change DataEngine data format (breaking changes)

Ver.2.4.0:
+ add support of weather items
+ add support of load average (la1, la5, la15 tags)
+ add "drop key cache" button
+ add support of clang building
+ create ExtItems aggregator
+ add time to debug information
+ add ability to disable player monitor
- fix bug with invalid network data calculation
- fix warning with fond dialog init
- fix bug with no object deletions (#60)
* rewrite ExtItems to use own abstract class
* improve work with data updating (#57)
* move to signal-slot interface painting
* move plugin part back to private
* cast plugin as type, not signleton (#57)
* change logic in data building inside DataEngine
* edit build and drop different DataEngine packaging
* rewrite QMap to QHash if possible
* rewrite to use iterators if possible
* list of desktops is now represented as QStringList
* refactoring

Ver.2.3.3:
* change text rendering from Qt to native

Ver.2.3.2:
+ change network speed units from KB/s to MB/s if value is more than 1000 KB/s (metrics are the same)
- fix bug with no actions on link activation (thanks to infans)
* improve quotes support, e.g. fix plasma crash
* rewrite main widget to signal-slot update model
* improve battery calculation for system which has several batteries

Ver.2.3.1:
- fix bug with no updates from configuration UI
- fix invalid vertical tab parsing
* translation update
* merge fan tags to temp ones, improve lmsensors tags handling

Ver.2.3.0:
+ implement fitlers support to ExtScripts (ApiVer = 3) (#53)
+ implement ability to wrap `\n` as new lines (#53)
+ implement key sorting in comboboxes
+ implement (perc)(bid|ask|price)chg tag support (ApiVer = 2)
+ implement timeouts to quotes (#54)
- fix bug with invalid html parsing
* move from XML to JSON in ExtQuotes (ApiVer = 2)
* more pretty configuration UI
* some part of refactoring

Ver.2.2.2:
+ add quotes support (#46)
+ add support of properties height and width (#47)
+ add transtaltion support to the plugins (#50)
+ add support of key caching
+ add support of X-AW-Number to ExtScript and ExtUpgrade (ApiVer = 2)
+ add reconnection to DataEngine (in some cases some values are not updated)
+ add widgets width and height update
- fix bug with Ext* items update (#49)
- fix bug with GPUDEV, HDDDEV settings saving from UI
- fix Desktop Panel settings
- fix bug with adding paragraph settings
* drop support of KDE4 support, created a separated branch
* increase intervals limits (#48)
* hddtemp was replaced to smartctl by default
* plugins were moved from private
* more correct interface painting

Ver.2.2.1:
+ add key X-AW-Interval to ExtUpgrade (ApiVer = 1, default = 3600)
+ add values cache to ExtScript and ExtUpgrade
+ add support isActive to ExtUpgrade
* change cmake version check
* improve logic of ExtScript and ExtUpgrade

Ver.2.2.0:
* port to Plasma 5
+ add support of windows list in tooltip
+ add notifications on system events
+ add ability to show selected tag
+ add tags $downN, $upN
+ add new engine netdev
+ add support of smartctl
- remove ability to hide panel on hotkey
* small changes in widget logic
* edit window preview painting
* KDE4 code upgrade to new ABI
* DataEngine optimization
* PKGCMD was replaced by ExtUpgrade

Ver.2.1.0:
+ add support of custom scripts
+ add support of desktop preview to DP
+ add bar support
+ add autoupdate function
- remove custom command
- fix #34
* fix notifications
* rewrite UI to KDE standards
* fix margins on graphical objects
* rewrite DP abd DE to use library calls
* edit GPU properties definition
* edit regexp matching

Ver.2.0.5:
+ add tooltip bottom (#30)
* fix network interface update
* fix battery tooltip bug
* edit DP layout (#31)

Ver.2.0.4:
* more correct work with batteries

Ver.2.0.3:
+ add support of several $bat tags
* edit layout

Ver.2.0.2:
+ add $fan* tags
+ add Chinese translation (thanks to @Lemueler)
+ add net devices checking is it p2p device
- remove ps stats from notification
* yet another fix cpu* and cpucl*
* rewrite DP configuration interface
* fix non-standard temp units

Ver.2.0.1:
+ add support of custom interfaces
* fix label edge's shading
* fix cpu*, cpucl*, gpu*, ps* tags

Ver.2.0.0:
+ add new widget - awesome widget
+ add new tags $hddfreemb, $hddfreegb, $memusedmb, $memusedgb, $memfreemb $memfreegb, $swapfreemb, $swapfreegb
+ add new DataEngine - battery
+ add new tooltip - battery
+ add new temperature units cm^-1, kcal/mol, kJ/mol, Reamur
+ add ability to hide panels by hotkey pressing
- remove widget pytextmonitor
- remove separate fields
- remove README
* project has been renamed to Awesome Widgets
* rename tag $custom (time) to $ctime
* rename tag $custom (uptime) to $cuptime
* rename tag $time (player) to $duration
* rename tag $number to $ndesktop
* rename tag $name to $desktop
* rename tag $total to $tdesktops
* debug flag is DEBUG now
* rewrite project to C++
* tooltip doesn't depend on widget now
* text align now can be configured only by using HTML tags
* move battery and AC settings to DataEngine
* changes in configuration interface

Ver.1.11.0:
+ add ability to disable background image
+ add desktop DataEngine
+ add PTM desktop panel
+ add desktop label (tags $name, $number, $total)
+ add ability to interact with players using mpris
* rewrite to use submodules
* rewrite DataEngine to use tasks
* fix nvidia temperature definition

Ver.1.10.2:
- fix error with tempUnits in hddtemp label

Ver.1.10.1:
- fix error with number formats in ps label
- fix first initialization of DataEngine
- fix checking of qmmp

Ver.1.10.0:
+ add tags $hddtotmb, $hddtotgb
+ add tags $memtotmb, $memtotgb, $swaptotmb, $swaptotgb
+ add ability for force update text
+ add support of clementine
+ add support of hddtemp cmd
+ add support of disable option for HDDDEV and GPUDEV
+ add error checking of DataEngine variables
+ add multithreading to DataEngine
+ add ability to disable popup messages
+ add ability to use vertical layout
+ add ability to add stretch
+ add ability to show debug information (set environment variable 'PTM_DEBUG' to 'yes')
+ add Brazillian Portuguese translation (@underr)
+ add Ukrainian translation (Виктор Слободян)
- remove util.py
- remove createNotifyrc since it isn't needed
* refactoring of configuration interface
* player settings was moved from plasmoid to DataEngine
* edit readme call
* change readme from md to html

Ver.1.9.0:
+ add support of several custom commands ($customN)
+ add hdd speed label ($hddrN, $hddwN)
+ add actions to context menu (open readme and run ksysguard)
- remove doubleclick event
* fix parsing pkg label

Ver.1.8.3:
+ add Spanish translation (thanks to Ernesto Avilés Vzqz)
+ add readme to the package

Ver.1.8.2:
+ add different temperature units (Farenheit and Kelvin)

Ver.1.8.1:
* change pkg update time to hour

Ver.1.8.0:
+ add scrollbar to configuration interface
+ add AC lines configuration
+ add $hddmbN, $hddgbN tags
+ add support of ps ($ps, $pscount, $pstotal tags)
+ add support of package managers ($pkgcountN tags)
* refactoring of DataEngine

Ver.1.7.4:
+ add support more than 10 tags in cpu, cpuclock, hdd, hddtemp, temp labels
- format bug fixes
* changes in custom uptime format

Ver.1.7.3:
+ add tags $memgb, $swapgb
+ add readme directory
+ add french translation (@Mermouy)
- fix tooltip for custom uptime format
- fix #12
* more refactoring to the god of refactoring
* network device update interval now is 30*interval
* $swap, $swapmb and $swapgb tags now work simultaneously ($mem* tags too)
* player_name now has str type

Ver.1.7.2:
+ add tags $dd, $d, $hh, $h, $mm, $m to custom uptime format
+ add scalling to tooltips
+ add DataEngine configuration from ptm
+ add custom command to DataEngine
- remove custom command from ptm
- remove tags $ds, $hs, $ms

Ver.1.7.1:
- remove error label
* fix bug with zero values in tooltip

Ver.1.7.0:
+ add support of several tags in temperature label
+ add tags $cpuN, $cpuclN, $hddN, $tempN, $hddtempN, $up, $down
+ add label with custom command
+ add tooltips for CPU, CPU clock, memory, swap and network labels
- remove tags @@...@@, $temp, $ccpu, $ccpucl, $net
* changes in settings
* ptm now does not require net-tools
* refactoring

Ver.1.6.1:
+ add support of several devices in hddtemp label
- fixed #6

Ver.1.6.0:
+ add $custom tag to time and uptime labels (#8)
+ russian translation
- fix #6, #10
* change license to GPLv3
* change project build

Ver.1.5.3:
+ add $album, $progress and $time tags to player label (#7)
- fix zero swap

Ver.1.5.2:
+ add $isotime, $shorttime and $longtime tags to time label

Ver.1.5.1:
+ add time label

Ver.1.5.0:
+ add player label

Ver.1.4.0:
+ add notifications

Ver.1.3.6:
- fix #1, #2

Ver.1.3.5:
- fix bug with definition network device

Ver.1.3.4:
+ add double click event
+ add auto selection of network device
- fix yet another plasma crash

Ver.1.3.3:
* edit reading temperature device

Ver.1.3.2b:
- fix plasma crash

Ver.1.3.2:
+ add GPU, GPU temperature, HDD and HDD temperature labels
+ add $ccpu and $ccpucl tags
- bug fixes
* optimization and refactoring

Ver.1.2.2:
+ add tooltip to lineEdit

Ver.1.2.1:
* if battery doesn't exist return 'off'
* if AC doesn't exist return '(?)'

Ver.1.2.0:
+ add $ac tag to battery label
+ add battery and ac device configurations
+ add error cheking
* $bat tag now reading from /sys/*

Ver.1.1.4:
* change parsing acpi output (battery label)

Ver.1.1.3:
+ add font weight
* edit font setup line. Now setup for font family works normaly
* small bug fix

Ver.1.1.2:
+ add CPU clock lable
+ add function to update network device (100*time_interval)
+ change update sliders

Ver.1.1.1:
+ add $swapmb, $memmb, $netdev, @@netdev=...@@ tags
- some bug fixes
* widget consists of several labels
* edit configuration interface

Ver.1.0:
First release
